"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = applyRules;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("react-jsonschema-form/lib/utils");

var _utils2 = require("./utils");

var _rulesRunner = require("./rulesRunner");

var _rulesRunner2 = _interopRequireDefault(_rulesRunner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function applyRules(schema, uiSchema, rules, Engine) {
  var extraActions = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};

  if ((0, _utils2.isDevelopment)()) {
    var propTypes = {
      Engine: _propTypes2.default.func.isRequired,
      rules: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        conditions: _propTypes2.default.object.isRequired,
        order: _propTypes2.default.number,
        event: _propTypes2.default.shape({
          type: _propTypes2.default.string.isRequired
        })
      })).isRequired,
      extraActions: _propTypes2.default.object
    };

    _propTypes2.default.checkPropTypes(propTypes, { rules: rules, Engine: Engine, extraActions: extraActions }, "props", "react-jsonschema-form-manager");
  }

  var runRules = (0, _rulesRunner2.default)(schema, uiSchema, rules, Engine, extraActions);

  return function (FormComponent) {
    var FormWithConditionals = function (_Component) {
      _inherits(FormWithConditionals, _Component);

      function FormWithConditionals(props) {
        _classCallCheck(this, FormWithConditionals);

        var _this = _possibleConstructorReturn(this, (FormWithConditionals.__proto__ || Object.getPrototypeOf(FormWithConditionals)).call(this, props));

        _this.updateSchema = function (formData) {
          _this.formData = formData;
          return runRules(formData).then(function (conf) {
            _this.setState(conf);
            return conf;
          });
        };

        _this.handleChange = function (state) {
          var formData = state.formData;

          var updTask = _this.updateSchema(formData);
          if (_this.props.onChange) {
            updTask.then(function (conf) {
              return _this.props.onChange(Object.assign({}, state, conf));
            });
          }
        };

        _this.state = { schema: schema, uiSchema: uiSchema };

        _this.updateSchema(_this.props.formData);
        return _this;
      }

      _createClass(FormWithConditionals, [{
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
          if (nextProps !== this.props && !(0, _utils.deepEquals)(nextProps.formData, this.formData)) {
            this.updateSchema(nextProps.formData);
            this.propsChanged = true;
          } else if (!(0, _utils.deepEquals)(nextProps, Object.assign({}, this.props, { formData: nextProps.formData }))) {
            this.propsChanged = true;
          }
        }
      }, {
        key: "shouldComponentUpdate",
        value: function shouldComponentUpdate(nextProps, nextState) {
          if (this.propsChanged) {
            this.propsChanged = false;
            return true;
          }
          return !(0, _utils.deepEquals)(this.state, nextState);
        }
      }, {
        key: "render",
        value: function render() {
          var configs = Object.assign({
            onChange: this.handleChange,
            formData: this.formData
          }, this.props, this.state);
          return _react2.default.createElement(FormComponent, configs);
        }
      }]);

      return FormWithConditionals;
    }(_react.Component);

    return FormWithConditionals;
  };
}